Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports System.Windows.Input

Namespace Interfaces
	''' <summary>
	''' See http://jake.ginnivan.net/awaitable-delegatecommand
	''' </summary>
	Public Interface IAsyncCommand
		Inherits IAsyncCommand(Of Object)
	End Interface

	Public Interface IAsyncCommand(Of  In T)
		Inherits IRaiseCanExecuteChanged
		Function ExecuteAsync(obj As T) As Task
		Function CanExecute(obj As Object) As Boolean
		ReadOnly Property Command() As ICommand
	End Interface

	Public Interface IRaiseCanExecuteChanged
		Overloads Sub RaiseCanExecuteChanged()
	End Interface
End Namespace
